import { ref as I, watch as M, computed as E, openBlock as r, createElementBlock as v, createElementVNode as p, createBlock as g, unref as d, withCtx as h, Fragment as L, renderList as V, normalizeClass as C, toDisplayString as S, createVNode as k, createCommentVNode as T, nextTick as B } from "vue";
import { ArrowRight as O, Check as R } from "../../../../../node_modules/@element-plus/icons-vue/dist/index.js";
import { ElTimeline as q, ElTimelineItem as G, ElIcon as D } from "element-plus";
import "./TimeLineFilter.vue2.js";
const H = { class: "time-line-filter" }, J = { class: "line-selected-content" }, K = { class: "custom-item" }, P = ["onClick"], Q = { class: "line-list-content" }, U = ["onClick"], ee = {
  __name: "TimeLineFilter",
  props: {
    data: {
      type: Array,
      default: []
    },
    option: {
      type: Object,
      default: {
        id: "id",
        name: "name",
        pId: "pId"
      }
    },
    modelValue: {
      type: String,
      default: ""
    }
  },
  emits: ["update:modelValue"],
  setup(N, { emit: j }) {
    const c = N, f = j, i = I([]), u = I("0"), s = I("");
    let m = !0;
    M(
      [() => c.modelValue, () => c.data],
      ([n, a]) => {
        if (n && a.length > 0 && m) {
          const e = n.split(",");
          i.value = a.filter((t) => e.includes(t.id + "")), i.value = i.value.map((t) => (t.isAct = !1, t));
          const l = y(a);
          e.length < l ? (u.value = e[e.length - 1], i.value.push({
            id: "pleaseSelect",
            name: "请选择",
            hollow: !0,
            isAct: !0,
            pId: u.value
          })) : (i.value[i.value.length - 1].isAct = !0, u.value = e[e.length - 2]), s.value = i.value[i.value.length - 1].id;
        }
      },
      {
        immediate: !0
      }
    );
    function y(n) {
      const a = {};
      let e = 0;
      return n.forEach((l) => {
        a[l.id] = { pId: l.pId, lvl: 0 };
      }), n.forEach((l) => {
        let t = l.id, o = 1;
        for (; a[t] && a[t].pId != "0"; )
          t = a[t].pId, o++;
        a[l.id].lvl = o, o > e && (e = o);
      }), e;
    }
    function b(n, a) {
      if (!a || a == 0)
        return n;
      function e(l) {
        if (l.id == a)
          return l.children;
        for (const t of l.children) {
          const o = e(t);
          if (o)
            return o;
        }
        return null;
      }
      for (const l of n) {
        const t = e(l);
        if (t)
          return t;
      }
      return null;
    }
    function A(n, a) {
      if (Array.isArray(n))
        for (let e = 0; e < n.length; e++) {
          const l = n[e];
          if (l.id === a)
            return l;
          if (l.children && l.children.length > 0) {
            const t = A(l.children, a);
            if (t)
              return t;
          }
        }
      return null;
    }
    const w = E(() => z(c.data)), F = E(() => b(w.value, u.value));
    function x(n) {
      m = !0, i.value.length >= n.lvl && (i.value = i.value.slice(0, n.lvl - 1)), i.value.push(n);
      const a = i.value.map((e) => e.id);
      f("update:modelValue", ""), B(() => {
        f("update:modelValue", a.join(","));
      });
    }
    function $(n) {
      if (n.id == "pleaseSelect") {
        const t = A(w.value, n.pId);
        x(t);
        return;
      }
      m = !1, u.value = n.pId;
      const a = i.value.findIndex((t) => t.id === n.id);
      a !== -1 && i.value.splice(a + 1), s.value = n.id, i.value.forEach((t) => {
        t.isAct = !1, n.id == t.id && (t.isAct = !0);
      });
      const e = i.value.map((t) => t.id), l = y(c.data);
      e.length < l && i.value.push({
        id: "pleaseSelect",
        name: "请选择",
        hollow: !0,
        isAct: !1,
        pId: n.id
      }), f("update:modelValue", ""), B(() => {
        f("update:modelValue", e.join(","));
      });
    }
    function z(n) {
      const a = {}, e = [];
      return n = n.map((l) => ({
        id: l[c.option.id],
        name: l[c.option.name],
        pId: l[c.option.pId],
        ...l
      })), n.forEach((l) => {
        a[l.id] = { ...l, children: [], lvl: 0 };
      }), n.forEach((l) => {
        const t = a[l.id], o = l.pId;
        if (o == "0")
          t.lvl = 1, e.push(t);
        else {
          const _ = a[o];
          _ && (t.lvl = _.lvl + 1, _.children.push(t));
        }
      }), e;
    }
    return (n, a) => (r(), v("div", H, [
      p("div", J, [
        i.value.length > 0 ? (r(), g(d(q), {
          key: 0,
          class: "selected-time-line"
        }, {
          default: h(() => [
            (r(!0), v(L, null, V(i.value, (e, l) => (r(), g(d(G), {
              center: "",
              type: "primary",
              hollow: e.hollow,
              "hide-timestamp": ""
            }, {
              default: h(() => [
                p("div", K, [
                  p("span", {
                    class: C(["label", { act: e.isAct || e.id == s.value }]),
                    onClick: (t) => $(e)
                  }, S(e.name), 11, P),
                  k(d(D), { style: { color: "#ccc" } }, {
                    default: h(() => [
                      k(d(O))
                    ]),
                    _: 1
                  })
                ])
              ]),
              _: 2
            }, 1032, ["hollow"]))), 256))
          ]),
          _: 1
        })) : T("", !0)
      ]),
      p("div", Q, [
        (r(!0), v(L, null, V(F.value, (e) => (r(), v("div", {
          class: C(["line-list-item", { act: e.id == s.value }]),
          onClick: (l) => x(e)
        }, [
          p("span", null, S(e.name), 1),
          e.id == s.value ? (r(), g(d(D), { key: 0 }, {
            default: h(() => [
              k(d(R))
            ]),
            _: 1
          })) : T("", !0)
        ], 10, U))), 256))
      ])
    ]));
  }
};
export {
  ee as default
};
