import { watch as n, ref as d, onMounted as l, toRaw as c, onBeforeUnmount as f, openBlock as h, createElementBlock as y, normalizeStyle as u } from "vue";
import E from "../../../../../node_modules/@opentiny/huicharts/core.js";
import "../../../../../node_modules/@opentiny/huicharts/register.js";
import "../../../../../node_modules/@opentiny/huicharts/feature/card/chartToken.js";
import "../../../../../node_modules/@opentiny/huicharts/components/BarChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/PieChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/LineChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/HillChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/WaveChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/TreeChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/FlowChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/RadarChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/GanttChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/GaugeChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/RiverChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/BubbleChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/RegionChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/FunnelChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/SankeyChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/BulletChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/ScatterChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/TreeMapChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/BoxplotChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/ProcessChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/JadeJueChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/HeatMapChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/TerraceChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/framework/charts/MindmapChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/BaiduMapChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/SunburstChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/PolarBarChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/TimelineChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/GraphTreeChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/WordCloudChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/HoneycombChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/SnowFlakeChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/MilestoneChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/LiquidfillChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/AutonaviMapChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/CandlestickChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/OrganizationChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/CircleProcessChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/components/AssembleBubbleChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/framework/charts/ForceDirectedChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/framework/charts/GridChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/framework/charts/CircleChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/framework/charts/LinearArcChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/framework/charts/CircleArcChart/index.js";
import "../../../../../node_modules/@opentiny/huicharts/framework/charts/CustomizeChart/index.js";
const ht = {
  __name: "BaseChart",
  props: {
    chart: {
      type: Object,
      default: {}
    },
    option: {
      type: Object,
      default: {}
    },
    isEmpty: {
      type: Boolean,
      default: !1
    },
    height: {
      type: String,
      default: "300px"
    },
    events: {
      type: Array,
      default: []
    }
  },
  emits: ["renderReady"],
  setup(o, { emit: a }) {
    const i = o;
    let t;
    n(
      i.option,
      (e) => {
        t && t.refresh(c(e));
      },
      {
        deep: !0
      }
    ), n(
      () => i.isEmpty,
      (e) => {
        t && (i.isEmpty ? m() : t.closeEmpty());
      }
    );
    function r(e) {
      t != null && t.echartsIns.containPixel("grid", [e.offsetX, e.offsetY]) || (t.dispatchAction({
        type: "hideTip"
      }), t.dispatchAction({
        type: "downplay"
      }), t.dispatchAction({
        type: "unselect"
      }));
    }
    const s = a, p = d();
    l(() => {
      t = new E(), t.init(p.value), t.setSimpleOption(i.chart, c(i.option)), t.onRenderReady(() => {
        t.setResize(), s("renderReady");
      }), t.bindEvents(i.events), t.render(), i.isEmpty && m(), document.addEventListener("click", r);
    }), f(() => {
      document.removeEventListener("click", r);
    });
    function m() {
      let e = { theme: "hdesign-light" };
      t.showEmpty(e);
    }
    return (e, g) => (h(), y("div", {
      ref_key: "chartContainerDom",
      ref: p,
      style: u("width: 100%;height:" + o.height)
    }, null, 4));
  }
};
export {
  ht as default
};
